import matplotlib.pyplot as plt
import numpy as np
import time
import serial

ser = serial.Serial('/dev/ttyACM0', 9600)

fig = plt.figure()
ax = fig.add_subplot(111)

# some X and Y data
x = np.arange(1000)
y = [0] * 1000

li, = ax.plot(x, y)

# draw and show it
ax.relim() 
ax.autoscale_view(True,True,True)
fig.canvas.draw()
plt.ylim(0,1024)
plt.show(block=False)

# loop to update the data
while True:
	try:	
		vals = []
		for i in range(10):
			while True:
				a = ser.readline()
				a = a.rstrip().decode('latin-1')
				try:
					vals.append(int(a))
					break
				except ValueError:
					pass

		y[:-10] = y[10:]
		y[-10:] = vals
		li.set_ydata(y)
		fig.canvas.draw()

		time.sleep(0.01)
	except KeyboardInterrupt:
		break
